"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replace = void 0;
var tslib_1 = require("tslib");
var postcss_1 = tslib_1.__importDefault(require("postcss"));
var memoizerific_1 = tslib_1.__importDefault(require("memoizerific"));
var postcss_px_to_viewport_1 = tslib_1.__importDefault(require("postcss-px-to-viewport"));
var configuration_1 = tslib_1.__importDefault(require("./configuration"));
var FAKE_OPENING_WRAPPER = 'styled-fake-wrapper/* start of styled-fake-wrapper */{';
var FAKE_CLOSING_WRAPPER = '}/* end of styled-fake-wrapper */';
var PAIR_REG = /[\s\w-]+:[\s\w-]+/;
exports.replace = memoizerific_1.default(10)(function (cssText) {
    var _a = configuration_1.default.config, tags = _a.tags, others = tslib_1.__rest(_a, ["tags"]);
    var options = tslib_1.__assign({}, others);
    try {
        var joinCssText = "" + FAKE_OPENING_WRAPPER + cssText + FAKE_CLOSING_WRAPPER;
        var css = postcss_1.default([postcss_px_to_viewport_1.default(options)]).process(joinCssText, {}).css;
        return css.replace(FAKE_OPENING_WRAPPER, '').replace(FAKE_CLOSING_WRAPPER, '');
    }
    catch (ignored) {
        var results = [];
        var tokens = cssText.split(';');
        for (var _i = 0, tokens_1 = tokens; _i < tokens_1.length; _i++) {
            var token = tokens_1[_i];
            if (PAIR_REG.test(token)) {
                results.push(exports.replace(token));
            }
            else {
                results.push(token);
            }
        }
        return results.join(';');
    }
});
